/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2011 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.internal.views;

import org.eclipse.gef.dnd.TemplateTransfer;
import org.eclipse.jface.util.LocalSelectionTransfer;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.dialogs.FilteredTree;
import org.eclipse.ui.dialogs.PatternFilter;
import org.eclipse.ui.part.ViewPart;
import org.fortiss.tooling.kernel.services.IPrototypeService;
import org.fortiss.tooling.kernel.services.IPrototypeService.Prototype;

/**
 * 
 * @author Eder
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @levd.rating RED Rev:
 */
public class LibraryView extends ViewPart {

	TreeViewer viewer;

	FilteredTree filteredTree;

	/** {@inheritDoc} */
	@Override
	public void createPartControl(Composite parent) {
		PatternFilter patternFilter = new PatternFilter();
		patternFilter.setIncludeLeadingWildcard(true);

		filteredTree = new FilteredTree(parent, SWT.SINGLE | SWT.H_SCROLL
				| SWT.V_SCROLL, patternFilter, false);
		viewer = filteredTree.getViewer();

		viewer.setContentProvider(new ITreeContentProvider() {

			@Override
			public Object[] getChildren(Object parentElement) {
				// TODO Auto-generated method stub
				return null;
			}

			@Override
			public Object getParent(Object element) {
				return null;
			}

			@Override
			public boolean hasChildren(Object element) {
				return false;
			}

			@Override
			public Object[] getElements(Object inputElement) {
				if (inputElement instanceof Object[]) {
					return (Object[]) inputElement;
				}
				return new Object[0];
			}

			@Override
			public void dispose() {
				// TODO Auto-generated method stub

			}

			@Override
			public void inputChanged(Viewer viewer, Object oldInput,
					Object newInput) {
				// TODO Auto-generated method stub

			}
		});
		viewer.setLabelProvider(new LibraryLabelProvider());
		viewer.addDragSupport(DND.DROP_COPY,
				new Transfer[] { TemplateTransfer.getInstance(),
						LocalSelectionTransfer.getTransfer() },
				new EObjectDragSourceListener(viewer));

		viewer.setInput(IPrototypeService.INSTANCE.getAllPrototypes().toArray());

		viewer.addFilter(new ViewerFilter() {

			@Override
			public boolean select(Viewer viewer, Object parentElement,
					Object element) {

				/*
				 * if (element instanceof Prototype) { EObject prototypeObject =
				 * ((Prototype) element).getPrototype(); return true; }
				 */
				return true;
			}

		});

		getViewSite().setSelectionProvider(viewer);
	}

	/** {@inheritDoc} */
	@Override
	public void setFocus() {
		viewer.getControl().setFocus();
	}

	/** The label provider used here-in. */
	private class LibraryLabelProvider extends LabelProvider {

		/** {@inheritDoc} */
		@Override
		public String getText(Object element) {
			if (element instanceof Prototype) {
				Prototype prototype = (Prototype) element;
				return prototype.getName();
			}
			return super.getText(element);

		}

		// TODO (JE): getImage
		/*
		 * @Override public Image getImage(Object element) { if (element
		 * instanceof Prototype) { Prototype prototype = (Prototype) element;
		 * return ModelElementService.getInstance().getImage(
		 * prototype.getPrototypeObject()); } return super.getImage(element); }
		 */

	}
}
